



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>jQuery EasyUI datagrid列名包含特殊字符会导致表格错位</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">jQuery EasyUI datagrid列名包含特殊字符会导致表格错位</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-29 22:57:23 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<div>
<p><strong>首先申明：本文所述的Bug存在于1.3.3以及更高版本中，其它低版本，本人未测试，太老的版本不想去折腾了。</strong></p>
<p>洒家在写前端的SQL执行工具时，表格用了&nbsp;jQuery EasyUI datagrid，因为用户的SQL是千奇百怪的，所以出现了诸如:"BLOCKS*8/1024","trunc(SYSDATE)"之类的列名(field)时，表格就会错位，而且含有特殊字符的列无法手工调整大小。</p>
<p>经分析，datagrid组件在画表格的时候会在宿主DOM后动态追加一个style节点，里面定义列的若干class，正是因为我们的field含有"* / # ( )..."等css中class无法识别的命名，导致class无效，从而引发了一连串血案。我们来看下，有问题的style节点：</p>
<div>
<ol><li>&lt;table&nbsp;id="resultTable"&nbsp;style="display:&nbsp;none;"&gt;&lt;/table&gt;</li>
<li>&lt;style&nbsp;type="text/css"&nbsp;easyui="true"&gt;</li>
<li>.datagrid-cell-c1-BLOCKS*8/1024{width:147px}</li>
<li>.datagrid-cell-c1-SEGMENT_NAME{width:231px}</li>
<li>.datagrid-cell-c1-TRUNC(SYSDATE){width:159px}</li>
<li>&lt;/style&gt;</li></ol>
</div>
<p>很明显第一个和第三个的class定义是无效的。那么这个问题究竟怎么破呢，源码的分析过程我就不说了，其实很简单，我们不使用field作为class后缀就行了，将field转换为十六进制是绝对安全的。下面来说说怎么改代码。</p>
<p>在&nbsp;jquery.easyui.min.js 文件中搜索 "[\.|\s]"关键字，请放心搜索，1.3.3(包含1.3.3)之后的各大版本均有销售，搜到之后你会发现这其实是一个replace函数的正则表达式，我们只要将replace函数的执行结果进一步替代成十六进制就可以了，于是乎，代码就变成了：</p>
<div>
<ol><li>field.replace(/[\.|\s]/g,&nbsp;"-").replace(/./g,function($1){return&nbsp;$1.charCodeAt(0).toString(16);});</li></ol>
</div>
<p>我在replace函数之后又replace了一次，目的是将其转为十六进制，这个修改方法应该是安全无毒副作用的，请大家放心使用。</p>
</div>
<p>　　</p>
<p><strong>&nbsp;</strong></p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/4qn11w28.html">2015 Autodesk 开发者日（ DevDays）和 助力开发周火热报名中</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8kopp5q.html">html5手机端遮罩弹出菜单代码</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9pg5349.html">python动态获取对象的属性和方法 （转载）</a>
		</li>
						<li><a href="https://www.batexi.com/a/0qwy1my8.html">【宽度优先搜索】神奇的状态压缩 CodeVs1004四子连棋</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pj7rm79.html">《ENVI下遥感影像自然真彩色合成方法》&mdash;&mdash;TM、spot5</a>
		</li>
						<li><a href="https://www.batexi.com/a/950gywz8.html">SpringMVC格式化显示</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv1jyvoq.html">使用&period;net 自建短链接（短网址）</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7z5dye9.html">javaScript设计模式之----工厂模式</a>
		</li>
						<li><a href="https://www.batexi.com/a/95gzlgmq.html">爬坑Linux</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7ojj2j8.html">Git应用--04遇到冲突解决办法git stash&lpar;转载&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv2w5ey9.html">Linux部署Web应用程序超链接下载中文名称文件404问题解决办法</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxd03y09.html">Python&amp;&num;160&semi;排错UnicodeEncodeError&amp;&num;160&semi;&amp;&num;39&semi;ascii&amp;&num;39&semi;&amp;&num;160&semi;codec&amp;&num;160&semi;can&amp;&num;39&semi;t&amp;&num;160&semi;encode&amp;&num;160&semi;character&amp;&num;160&semi;错误解决方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/902pl14q.html">NodeJS框架express的路径映射（路由）功能及控制</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdjgmlvq.html">springboot整合mybatis将sql打印到日志</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwovowl9.html">ios 开发之旅</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvd2ynyq.html">spfa 的算法实现之一</a>
		</li>
						<li><a href="https://www.batexi.com/a/q15vne09.html">SAP Odata実行命令&lpar;1&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e0x74jq.html">hdu 1520Anniversary party 树形dp入门</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlo3oy1q.html">IOS 多线程-pthread</a>
		</li>
						<li><a href="https://www.batexi.com/a/95podozq.html">java多线程实现复制大文件</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/93w0pezq.html">一&colon;理解ASP&period;NET的运行机制&lpar;例&colon;通过HttpModule来计算页面执行时间&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/93w0jdwq.html">06 - JavaSE之常用类</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwv7onl8.html">联系动词Link&period;V笔记</a>
			</li>
						<li><a href="https://www.batexi.com/a/8kj3mxr9.html">前端组件化Polymer入门教程&lpar;2&rpar;&mdash;&mdash;Hello world</a>
			</li>
						<li><a href="https://www.batexi.com/a/qyye41mq.html">观察者模式&mdash;&mdash;java设计模式</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7oplne8.html">spring boot 与 thymeleaf &lpar;1&rpar;&colon; 国际化</a>
			</li>
						<li><a href="https://www.batexi.com/a/8e4poee9.html">ASP&period;NET MVC HtmlHelper 类的扩展方法</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7opgok8.html">MySQL问答整理</a>
			</li>
						<li><a href="https://www.batexi.com/a/9j1yl7w9.html">APP---发布动态、朋友圈类似，多张图片动响应式正方形展示布局  vue&period;js，aui&period;css，apiclouv</a>
			</li>
						<li><a href="https://www.batexi.com/a/qv2gjy19.html">Linq 处理 List数据</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
